module debouncing (in_key, in_clk, in_reset, out_key);

input in_key;
input in_clk;
input in_reset;

output out_key;

reg res_trig;
reg trig1;
reg trig2;
reg div_clk;
reg [12:0] counter;

assign out_key = trig1 & trig2;

//counter
always @(posedge in_clk)
	begin
		if(in_reset == 1'd0)
			begin
				counter <= 13'd0;
			end
		else
			begin 
				if(counter < 13'd1000) counter <= counter + 1;
				else counter <= 13'd0;
			end
	end	
//div_clk
always @(posedge in_clk)
	begin
		if(in_reset == 1'd0)
			begin
				div_clk <= 1'd0;
			end
		else
			begin
				if(counter == 13'd1000) div_clk <= ~div_clk;
			end
	end
//res_trig
always @(posedge in_clk)
	begin
		if(in_reset == 1'd0)
			begin
				res_trig <= 1'd0;
			end
		else if(div_clk == 1'd1) res_trig <= 1'd1;
	end
//trig1
always @(posedge div_clk)
	begin
		if(res_trig == 1'd0)
			begin
				trig1 <= 1'd1;
			end
		else
			begin
				trig1 <= in_key;
			end
	end
//trig2
always @(posedge div_clk)
	begin
		if(res_trig == 1'd0)
			begin
				trig2 <= 1'd0;
			end
		else
			begin
				trig2 <= ~trig1;
			end
	end
endmodule