module ldm5(in_clk, sclk_arm, mosi, ss_arm,in_sdo, in_key,
miso, out_sclk_dac, out_sdio, out_ss_dac, out_pattern1, out_pattern2, out_led, out_reset_dac, out_clk_dac, /*addr_buf, /*test*/);

input sclk_arm;
input mosi;
input ss_arm;
input in_sdo;
input in_clk;
input in_key;

output out_clk_dac;
output miso;
output out_sclk_dac;
output out_sdio;
output out_ss_dac;
output out_led;
output out_reset_dac;
output [15:0] out_pattern1;
output [15:0] out_pattern2;
output [7:0] addr_buf;
output test;

wire clk200;
wire clk100;
wire clk10;
wire global_reset;
wire sdo;
wire sdio;
wire sclk_dac;
wire ss_dac;
wire sdo_demo;
wire sdio_demo;
wire sclk_dac_demo;
wire ss_dac_demo;
wire [15:0] demo_pattern1;
wire [15:0] demo_pattern2;
wire [15:0] pattern1;
wire [15:0] pattern2;
wire enable_demo;
wire key;
wire busy_spi;
wire [15:0] out_data;
wire start;
wire pll_com;
wire clk_ram;
wire rden;
wire wren;
wire [12:0] addr;
wire [11:0] ram1_data;
wire [11:0] ram2_data;

assign out_clk_dac = in_clk;
assign out_sdio = sdio_demo;
assign out_ss_dac = ss_dac_demo;
assign out_sclk_dac = sclk_dac_demo;
assign out_pattern1 = demo_pattern1;
assign out_pattern2 = demo_pattern2;

nucleus nucleus( 
.in_clk(clk100), 
.in_clk_160(clk100), 
.in_reset(global_reset), 
.in_sclk_arm(sclk_arm), 
.in_mosi_arm(mosi), 
.in_ss_arm(ss_arm), 
.in_sdo_dac(in_sdo),
.out_miso_arm(miso), 
.out_sclk_dac(sclk_dac), 
.out_sdio_dac(sdio), 
.out_ss_dac(ss_dac), 
.out_enable_demo(enable_demo),
.out_pattern1(pattern1),
.out_pattern2(pattern2), 
.out_clk_ram(clk_ram), 
.out_rden(rden), 
.out_wren(wren), 
.out_addr(addr),
.out_addr_buf(addr_buf),
.out_test(test));

demo demo(
.in_clk(clk200), 
.in_reset(global_reset), 
.in_enable(enable_demo), 
.in_key(key), 
.in_busy(busy_spi), 
.out_data(out_data), 
.out_start(start), 
.out_data_dac1(demo_pattern1), 
.out_data_dac2(demo_pattern2), 
.out_led(out_led));

spi_master_dac spi(
.in_clk(clk10), 
.in_reset(global_reset), 
.in_sdo(sdo_demo), 
.in_data_out(out_data), 
.in_start(start), 
.out_sclk(sclk_dac_demo), 
.out_ss(ss_dac_demo), 
.out_sdio(sdio_demo), 
.out_busy(busy_spi));

reset_control reset(
.in_pll(pll_com), 
.in_clk(clk200), 
.out_reset(global_reset), 
.out_reset_dac(out_reset_dac));

debouncing debouncing(
.in_key(in_key), 
.in_clk(clk10), 
.in_reset(global_reset), 
.out_key(key));

pll pll(
.inclk0(in_clk),
.c0(clk200),
.c1(clk100),
.c2(clk10),
.locked(pll_com));

pll160 pll160(
.inclk0(in_clk),
.c0(clk160));

ram1 ram1(
.address(addr),
.clock(clk_ram),
.data(pattern1),
.rden(rden),
.wren(wren),
.q(ram1_data));

ram2 ram2(
.address(addr),
.clock(clk_ram),
.data(pattern2),
.wren(wren),
.q(ram2_data));

endmodule